<!DOCTYPE html>
<html lang="en">
    <head>
        <title>KMP Algorithm</title>
        <meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
        <meta charset="utf-8"/>
        <style>
         .exp {
             display:none;
         }
         table {
             font-family: arial, sans-serif;
             border-collapse: collapse;
             width: 100%;
             text-align: center;
         }
         th {
             background-color:#2780C6;
             text-align: center !important;
             color:#fff;
         }
         #headings {
             background-color:#2780C6;
             text-align: center;
             color:#fff;
         }
         td {
             border: 1px solid #dddddd;
             padding: 8px;
             text-align: center;
             height:20px;
         }
         tr:hover {
             background-color: #ddd;
         }
        </style>
        <!-- Google Tag Manager -->
        <script class="gtm">
          window.dataLayer = window.dataLayer || [];
          
          window.dataLayer.push ({
          'labName': 'Data Structures – 2',
          'discipline': 'Computer Science and Engineering',
          'college': 'IIITH',
          'phase': '3',
          'expName': 'KMP Algorithm',
          'expShortName': 'kmp-algorithm'
          });


          (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
          new Date().getTime(),event:'gtm.js'});var
          f=d.getElementsByTagName(s)[0],
          j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
          'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
          })(window,document,'script','dataLayer','GTM-W59SWTR');
        </script>
        <!-- End Google Tag Manager -->

        <!-- Math Jax Library: Its used for rendering mathematical expressions defined in content -->
        <script async src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/MathJax.js?config=TeX-MML-AM_CHTML">
        </script>
    </head>
    <body>
        <!-- Google Tag Manager (noscript) -->
        <noscript class="gtm">
          <iframe height="0" width="0"
            src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
            style="display:none;visibility:hidden">
          </iframe>
        </noscript>
        <!-- End Google Tag Manager (noscript) -->

        <div class="exp" title="KMP Algorithm Module">
            <div class="longt">
                <h1 class="hlongt">Introduction to KMP Algorithm</h1>
            </div>

            <div class="preamble">
                <div class="art txt" title="Estimation">
                <div class="longt">
                <h2 class="hlongt">Estimated Time</h2>
                    </div>
                <div class="art-body">
                <p>2.5 hour</p>
                    </div>
                </div>

                <div class="art req" title="Introduction Video">
                <div class="longt">
                <h2 class="hlongt">A Short Introduction to the Overall Experiment</h2>
                    </div>
                <div class="description">
                <p>Introduction video for KMP</p>
                    </div>
                </div>

                <div class="art txt" title="Prerequisites">
                <div class="longt">
                <h2 class="hlongt">Prerequisites of the Experiment</h2>
                    </div>
                <div class="art-body">
                <p>This experiment requires you to have basic knowledge about :</p>
                <ul>
                <li><a href="https://en.wikipedia.org/wiki/Substring">Understanding of Prefix and Suffix of a String</a></li>
                <li><a href="https://en.wikipedia.org/wiki/Time_complexity">Notion of Time and Space complexity</a></li>
                        </ul>
                <p>And above all, a curiosity to learn and explore!</p>
                    </div>
                </div>

                <div class="art txt" title="Overview">
                <div class="longt">
                <h2 class="hlongt">Overview of the Experiment</h2>
                    </div>
                <div class="art-body">
                <ul>
                <li>
                The aim of this experiment
                is to understand the
                intricacies of string
                searching and then delve
                further into the
                Knuth-Morris-Pratt
                Algorithm, its Time and
                Space Complexity, and how it
                compares against naive
                searching algorithm.
                            </li>
                <li>
                The experiment features a
                series of modules with video
                lectures, interactive
                demonstrations, simulations,
                hands-on practice exercises
                and quizzes for self
                analysis.
                            </li>
                        </ul>
                    </div>
                </div>

                <div class="art txt" title="Learning Objectives">
                <div class="longt">
                <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                    </div>
                <div class="art-body">
                <p>In this experiment, you will be able to do the following:</p>
                <ul>
                <li>Search for a pattern in the
                string using naive string
                search method.
                            </li>
                <li>Find the
                Lowest-Prefix-Suffix array
                for a search pattern by
                preprocessing
                            </li>
                <li>Given a search string and a
                pattern to search in that
                string, you will be able to
                search for that pattern in
                the search string using KMP
                algorithm
                            </li>
                <li>Understand the intricacies
                of KMP algorithm and Naive
                string searching algorithm.
                            </li>    
                        </ul>                        
                    </div>
                </div>

                <div class="art txt" title="Modules and Weightage">
                <div class="longt">
                <h2 class="hlongt">Experiment Modules and their Weightage</h2>
                    </div>
                <div class="art-body">
                        <table>
                <thead>
                                <tr>
                                <th>Module</th>
                                <th>Weightage</th>
                                <th>Expectation</th>
                        </tr>
                            </thead>
                                <tbody>
                                <tr>
                                <td>Pre-Test</td>
                                <td>10%</td>
                                <td>Solve All Questions</td>
                        </tr>
                                <tr>
                                <td>Naive String Searching</td>
                                <td>25%</td>
                                <td>Understand basic algorithm of Naive String Searching</td>
                        </tr>
                                <tr>
                                <td>Preprocessing for LPS</td>
                                <td>25%</td>
                                <td>Understand the Lowest-Prefix-Suffix array creation process </td>
                        </tr>
                                <tr>
                                <td>KMP Algorithm</td>
                                <td>25%</td>
                                <td>Understand the Knuth-Morris-Pratt Algorithm</td>
                        </tr>
                                <tr>
                                <td>Post-test</td>
                                <td>15%</td>
                                <td>Solve all Questions</td>
                        </tr>
                    </tbody>
                    </table>
                    </div>
                </div>
            </div>

            <div class="lu" title="Pre-Test">
                <div class="longt" >
                    <h1 class="hlongt">Pre-Test of the Experiment</h1>
                </div>

                <div class="preamble">
                <div class="art txt" title="Estimation">
                <div class="longt">
                <h2 class="hlongt">Estimated Time</h2>
                        </div>
                <div class="art-body">
                <p>10 minutes</p>
                        </div>
                    </div>

                <div class="art txt" title="Instructions">
                <div class="longt">
                <h2 class="hlongt">Instructions for Pre-Test</h2>
                        </div>
                <div class="art-body">                            
                <ul>
                <li>Pretest includes questions on
                <strong>prefix and suffix</strong>
                                </li>
                <li>Read the questions in
                the quiz section and select the
                correct option from the ones
                provided. Please note that some
                <strong>questions may have more than one
                correct response.</strong>
                                </li>
                            </ul>                            
                        </div>
                    </div>
                </div>

                <div class="quiz" title="Pre-Test Quiz">
                <div class="longt">
                <h2 class="hlongt">A Quiz with
                Multiple Choice Questions about
                Substrings and Time-Complexity
                notations</h2>
                    </div>                    

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question1">
                <div class="art-body">
                <p>Q1. Which of these best describes a substring?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c1">
                <div class="art-body">
                <p>(A) A contiguous sequence of characters within a string in any order</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q1-c2">
                <div class="art-body">
                <p>(B) contiguous sequence of characters within a string in the same order</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c3">
                <div class="art-body">
                <p>(C) Any combination of a subset of characters from a string in any order.</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c4">
                <div class="art-body">
                <p>(D) Any combination of a subset of characters from a string in the same order as the string.</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>A substring is a
                contiguous sequence
                of characters within
                a string. For
                instance, "the best
                of" is a substring of
                "It was the best of
                times". This is not
                to be confused with
                subsequence, which is
                a generalization of
                substring. For
                example, "Itwastimes"
                is a subsequence of
                "It was the best of
                times", but not a
                substring.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question2">
                <div class="art-body">
                <p>Q2. Which one of the following is not a prefix of the word "TIKI-TAKA-TIK-TI"?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) TAKA</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) TIKI</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) TI</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) TIK</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p> TAKA is not a prefix of the word.
                                    </p>
                                </div>
                            </div>
                        </div>
            </div>

                        <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question3">
                <div class="art-body">
                <p>Q3. What does it mean
                when we say that an
                algorithm X is
                asymptotically more
                efficient than Y?
                                    </p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c1">
                <div class="art-body">
                <p>(A) X will always be a better choice for small inputs</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q1-c2">
                <div class="art-body">
                <p>(B) X will always be a better choice for large inputs</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c3">
                <div class="art-body">
                <p>(C) Y will always be a better choice for small inputs</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c4">
                <div class="art-body">
                <p>(D) X will always be a better choice for all inputs</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>Performance could be
                similar for small
                inputs, but
                definitely better for
                larger inputs.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question4">
                <div class="art-body">
                <p>Q4. int a = 0, b = 0; <br>
                for (i = 0; i &lt; N; i++) {<br>
                a = a + rand();<br>
                }<br>
                for (j = 0; j &lt; M; j++) {<br>
                b = b + rand();<br>
                }<br>
                What is the time and space complexity for the above code?
                                    </p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) O(N * M) time, O(1) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) O(N + M) time, O(N + M) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) O(N + M) time, O(1) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) O(N * M) time, O(N + M) space</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>The first loop runs
                for O(n) time, second
                loop runs for O(m).
                Constant extra space
                is used for 2
                variables a and b,
                hence O(1) space.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>                    
                </div>
            </div>

            <div class="lu" title="Naive String Searching">
                <div class="longt">
                <h2 class="hlongt">Naive String Searching</h2>
                </div>

                <div class="preamble">
                <div class="art txt" title="Estimation">
                <div class="longt">
                <h2 class="hlongt">Estimated Time</h2>
                        </div>
                <div class="art-body">
                <p>30 minutes</p>
                        </div>
                    </div>

                <div class="art req" title="Naive String Searching Concept">
                <div class="longt">
                <h2 class="hlongt">Demonstration of Naive String Searching Concept</h2>
                        </div>
                <div class="description">
                <p>Naive String Searching Video:1</p>
                        </div>
                </div>

                <div class="art txt" title="Learning Objectives">
                <div class="longt">
                <h2 class="hlongt">Learning Objectives of this Module</h2>
                        </div>
                <div class="art-body">
                <p>In this module, we will : </p>
                <ul>
                <li>Get introduced to string searching</li>
                <li>Learn the algorithm of naive string searching</li>
                <li>Learn the time and space complexity of naive string searching</li>
                <li>Practice the algorithm</li>
                <li>Test your conceptual understanding with a short quiz</li>
                            </ul>
                        </div>
                    </div>
                </div>

                <div class="task" title="Introduction : Why?">
                <div class="longt">
                <h2 class="hlongt">Introduction : Why?</h2>
                    </div>
                
                <div class="art txt" title="Why we need String Searching?">
                <div class="longt">
                <h2 class="hlongt">Why we need String Searching?</h2>
                        </div>
                <div class="art-body">
                    <p>
                    <ul>
                    <li>
                    Surprisingly, strings are
                    more often used in computer
                    science than numbers.  May it
                    be editing text documents in
                    word processors, reading our
                    favourite blogs or even a
                    basic search on google. </li>
                    <li>
                    Strings are everywhere.
                    Hence it is important to
                    study and understand the
                    methods to manipulate,
                    traverse and search among
                    them.
                    </li>
                    </p>     
                    </ul> 
                        </div>
                    </div>

                <div class="art txt" title="Real Life Applications">
                <div class="longt">
                <h2 class="hlongt">Real Life Applications</h2>
                        </div>
                <div class="art-body">                            
                <p>Efficient string searching is
                crucial to the way the
                internet functions
                today. They have a plethora
                of uses and applications:
                            </p>
                <ul>
                <li>Spell Checkers</li>
                <li>Intrusion Detection systems</li>
                <li>Predictive Seach Engines</li>
                <li>Plagiarism detection</li>
                <li>Information Retrieval System etc.</li>
                            </ul>                            
                        </div>
                    </div>

                <div class="art txt" title="Building the Intuition">
                <div class="longt">
                <h2 class="hlongt">Basic Approach</h2>
                        </div>
                <div class="art-body">
                <p>
                If we were to approach this
                problem of searching for a
                pattern inside a string, the
                first trivial solution would
                be a brute-force method.  We
                will be examining this
                method in the next task of
                this learning unit.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Concept and Strategy : Naive">
                <div class="longt">
                <h2 class="hlongt">How Naive String Searching Works?</h2>
                    </div>

                <!--div class="art req" title="Naive String Searching Algorithm">
                <div class="longt">
                <h2 class="hlongt">Demonstration of Naive String Searching Algorithm</h2>
                        </div>
                <div class="description">
                <p>Video of naive string searching</p>
                        </div>
                </div-->

                <div class="art txt" title="Explanation">
                <div class="longt">
                <h2 class="hlongt">Explanation</h2>
                        </div>
                <div class="art-body">
                <p>The brute-force method to find a pattern in a given string text is: </p>
                <ul>
                <li>Have two pointers strInd
                and patInd pointing at
                string beginning and
                pattern beginning.
                                </li>
                <li>Compare the characters
                present at the pointer.
                                </li>
                <li>If they match, increase
                both the pointers by
                one.
                                </li>
                <li>Repeat unless all the
                characters of pattern
                match or there is a
                mismatch
                                </li>
                <li>If all the letters of
                the pattern have been
                matched then we have
                found the pattern in the
                string.
                                </li>
                <li>If there is a mismatch:
                <ul>
                <li>Bring the patInd
                pointer back to
                the beginning of
                the pattern
                                        </li>
                <li>Bring the strInd
                pointer to the
                second position
                of the string
                now and Repeat
                the process.
                                        </li>
                <li>If another
                mismatch is
                encountered ,
                bring the strInd
                to the 3rd
                position of the
                string and so
                on.
                                        </li>
                                    </ul>
                                </li>
                <li>If strInd ever increases
                beyond the length of the
                string then return 0
                since it means that the
                pattern doesn't exist in
                the string.
                                </li>
                            </ul>                            
                        </div>
                    </div>

                <div class="art req" title="Naive Visualization">
                <div class="longt">
                <h2 class="hlongt">Iteration by
                Iteration Visualization of
                Naive String Searching
                Algorithm
                            </h2>
                        </div>
                <div class="description">
                <p>Image shows Iteration by
                Iteration Visualization of
                Naive basiyan
                            </p>
                        </div>
                    </div>

                <div class="art txt" title="Analysis">
                <div class="longt">
                <h2 class="hlongt">Time Complexity</h2>
                        </div>
                <div class="art-body">
                <p>Note: It is recommended to
                see the interactive demo task
                before reading this.
                <br><br>
                Deciding the big O notation
                for any algorithm is a
                function of the worst-case
                scenario of the
                algorithm. Let us consider a
                case - the pattern of length
                M to be searched in a string
                of length N always fails on
                the pattern's last character
                and succeeds only at the end
                of the string.
                <br><br>
                Example : <br>
                <b>String</b> : AAAAAAAAAAAAAAAAAAAAAAX <br>
                <b>Pattern</b>  : AAAAAX <br><br>  
                
                Assuming that the time
                required to compare two
                characters is O(1) then the
                above case will take Time =
                O(M \times N)
                <br>
                Hence the naive string
                searching algorithm is of the
                complexity <b>\(O(M \times N)\)</b>
                            </p>
                        </div>
                    </div>

                </div>

                <div class="task" title="Naive String Searching Demo">
                <div class="longt">
                <h2 class="hlongt">Demonstration of the Algorithm</h2>
                    </div>
                <div class="art req" title="Naive String Searching Demo">
                <div class="longt">
                <h2 class="hlongt">Demo : Simple String Searching Demo</h2>
                        </div>
                <div class="description">
                <p>Interactive artefact where
                user can click on Next Step
                to understand how string
                searching works.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="quiz" title="Naive String Searching Quiz">
                <div class="longt">
                <h2 class="hlongt">Revision Quiz for Naive String Searching</h2>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question1">
                <div class="art-body">
                <p>Q1. What do we do
                when matching of a
                character fails while
                comparing the pattern
                to the string?
                                    </p>
                                </div>
                            </div>
                        </div>
                
                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c1">
                <div class="art-body">
                <p>(A) Shift the pattern by one unit</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c2">
                <div class="art-body">
                <p>(B) Set the value of strInd to strInd - patInd + 1</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c3">
                <div class="art-body">
                <p>(C) Set the value of patInd to 0</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q1-c4">
                <div class="art-body">
                <p>(D) All of the above</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>The pattern is
                shifted to the right
                by one by setting the
                patInd to 0 after
                setting strInd to
                strInd - patInd + 1
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question2">
                <div class="art-body">
                <p>Q2. What is
                theoretrically the
                best time complexity
                for any string
                searching algorithm
                for searching a
                pattern of length
                \(M\) in a text of
                length \(N\)?
                                    </p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) \( O(N+M) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) \( O(M \times N) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) \( O(N^M) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) None of these</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>It is necessary to
                read all the
                characters of the
                text atleast once
                inorder to
                deterministically say
                that the pattern
                doesn't exist in the
                text. 
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question3">
                <div class="art-body">
                <p>Q3. What is the time complexity of Naive-String-Searching Algorithm?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) \( O(N+M) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) \( O(N \times M) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) \( O(N^M) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) None of these</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p> Refer to "Concept and Strategy : Naive" for the explanation.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="lu" title="Knuth-Morris-Pratt Algorithm">
                <div class="longt">
                <h2 class="hlongt">Knuth-Morris-Pratt Algorithm</h2>
                </div>

                <div class="preamble">
                <div class="art txt" title="Estimation">
                <div class="longt">
                <h2 class="hlongt">Estimated Time</h2>
                        </div>
                <div class="art-body">
                <p>40 minutes</p>
                        </div>
                    </div>

                <div class="art req" title="Optimized KMP Concept">
                <div class="longt">
                <h2 class="hlongt">Demonstration of Optimized KMP Concept</h2>
                        </div>
                <div class="description">
                <p>Video for Optimized KMP algorithm</p>
                        </div>
                </div>

                <div class="art txt" title="Learning Objectives">
                <div class="longt">
                <h2 class="hlongt">Learning Objectives of this Module</h2>
                        </div>
                <div class="art-body">
                <p>In this module, we will:</p>     
                <ul>
                <li>Learn KMP string searching algorithm.</li>
                <li>Observe some characteristics of the algorithm</li>
                <li>Understand how we can use them optimise the algorithm</li>
                <li>Practice the algorithm</li>
                <li>Test your conceptual understanding with a short quiz</li>
                            </ul>
                        </div>
                    </div>
                </div>

                <div class="task" title="Intro to LPS Array">
                <div class="longt">
                <h2 class="hlongt">Intro to Lowest-Prefix-Suffix Array</h2>
                    </div>

                <div class="art txt" title="Basic Intuition">
                <div class="longt">
                <h2 class="hlongt">Building Intuition</h2>
                        </div>
                <div class="art-body">
                <p>
                <ul>
                <li>
                Let us think of a method by
                which we can make our
                bruteforce method more
                efficient. We notice that we
                have been doing redundant
                matching when the matching of
                a pattern in a string fails
                since we are moving the
                string Index back. Can we
                possibly track the
                information we get from
                previous comparisons? </li>
                <li>
                We have to exploit the
                degenerating property of the
                pattern we are searching. i.e
                pattern having same
                sub-patterns appearing more
                than once in the pattern. </li>
                </ul>
                </p>
                        </div>
                    </div>

                <div class="art req" title="LPS Visualization">
                <div class="longt">
                <h2 class="hlongt">Finding Repeating Substrings</h2>
                        </div>
                <div class="description">
                <p>image for showing the overlap goes here</p>
                        </div>
                    </div>

                <div class="art txt" title="LPS Array">
                <div class="longt">
                <h2 class="hlongt">The Longest-Prefix-Suffix Array</h2>
                        </div>
                <div class="art-body">
                <p>The name LPS indicates the
                longest proper prefix which
                is also a suffix of the
                matched pattern.<br><br>
                Example:<br>
                AA in <br>
                AABAA is a prefix as well as
                a suffix. <br>
                In case AABAAC is the pattern
                which we are searching in
                some unknown string. And we
                happen to know that after
                successfully matching AABAA,
                C is a mismatch. <br>
                Then we can start matching
                the 3rd letter of pattern(B)
                to the letter at strInd
                instead of starting from the
                beginning. <br><br>

                <b>Definition : </b> <br>
                Let us define the LPS array
                for a pattern such that
                lps[i] stores the index of
                the pattern from where we
                must begin comparing if the
                match fails after rightly
                matching the pattern until
                that point.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Concept And Strategy : KMP">
                <div class="longt">
                <h2 class="hlongt">Concept And Strategy : KMP</h2>
                    </div>
                
                <!--div class="art req" title="Optimized KMP Algorithm">
                <div class="longt">
                <h2 class="hlongt">Optimized KMP Algorithm Explanation with an Example</h2>
                        </div>
                <div class="description">
                <p>Video for Optimized KMP algorithm</p>
                        </div>
                </div-->

                <div class="art txt" title="Explanation">
                <div class="longt">
                <h2 class="hlongt">Explanation</h2>
                        </div>

                <div class="art-body">            
                <p>Unlike the bruteforce
                approach where we just shift
                the pattern by and start
                comparing again, we must use
                a value from the LPS Array to
                decide which character to
                compare next. The core idea
                is to avoid comparing the
                characters which we know will
                match correctly anyway. 
                            </p>                            
                        </div>
                    </div>

                <div class="art txt" title="Algorithm">
                <div class="longt">
                <h2 class="hlongt">Algorithm</h2>
                        </div>

                <div class="art-body">                            
                <ul>
                <li>We start comparing
                pattern (pat[patInd])
                with patInd = 0 </li>
                <li>We keep comparing
                letters pat[patInd] and
                string[strInd] and
                increment patInd and
                strInd as long as they
                match</li>
                <li>
                When we see a mismatch :
                <ul>
                <li>We are aware
                that pat[0 to
                patInd-1] match
                correctly with
                string[strInd-patInd
                to strInd-1].</li>
                <li>From the way we
                had defined LPS
                Array, we know
                that
                LPS[patInd-1] is
                a count of
                characters of
                pat[0 to
                patInd-1] which
                are both prefix
                and suffix.</li>
                <li>So, we don’t
                need to compare
                these characters
                as they are
                going to match
                anyway.
                                        </li>
                                    </ul>
                                </li>
                            </ul>                            
                        </div>
                    </div>

                <div class="art req" title="KMP Algorithm Visualization">
                <div class="longt">
                <h2 class="hlongt">Step by Step iteration example of KMP Algorithm</h2>
                        </div>
                <div class="description">
                <p>Image for kmp algo made by friendly neighbourhood spiderman</p>
                        </div>
                    </div>

                <div class="art txt" title="Pseudocode">
                <div class="longt">
                <h2 class="hlongt">Pseudocode</h2>
                        </div>
                <div class="art-body">
                <pre style="font-size: 1vw">
                            strInd = 0
                            patInd = 0
                            
                            while(strInd &lt; string.length()) {
                                if(pat[patInd] == string[strInd]){
                                    if(patInd == pat.length()-1){
                                        print("Match Found at" + strInd-pat.length() )
                                        return 
                                    }
                                    
                                    strInd++;
                                    patInd++;
                                }
                                else {
                                    if(patInd != 0){
                                        patInd = LPS[patInd-1]
                                    }
                                    else {
                                        strInd++;
                                    }
                                }
                            }
                            </pre>                            
                        </div>
                    </div>
                </div>

                <div class="task" title="KMP Algorithm Demo">
                <div class="longt">
                <h2 class="hlongt">Demonstration for KMP String Matching</h2>
                    </div>
                
                <div class="art req" title="KMP String Searching Demo">
                <div class="longt">
                <h2 class="hlongt">KMP String Searching Demo</h2>
                        </div>                        
                <div class="description">
                <p>Interactive artefact where
                user can click on Next Step
                to understand how the kmp
                string searching algorithm
                works.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="task" title="KMP Algorithm Practice">
                <div class="longt">
                <h2 class="hlongt">Demonstration for KMP String Matching</h2>
                    </div>
                
                <div class="art req" title="KMP String Searching Practice">
                <div class="longt">
                <h2 class="hlongt">KMP String Searching Practice</h2>
                        </div> 
                <div class="description">
                <p>Interactive artefact where
                user can click on Next Step
                to understand how the kmp
                string searching algorithm
                works.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="task" title="KMP Algorithm Exercise">
                <div class="longt">
                <h2 class="hlongt">Demonstration for KMP String Matching</h2>
                    </div>
                
                <div class="art req" title="KMP String Searching Exercise">
                <div class="longt">
                <h2 class="hlongt">KMP String Searching Exercise</h2>
                        </div> 
                <div class="description">
                <p>Interactive artefact where
                user can click on Next Step
                to understand how the kmp
                string searching algorithm
                works.
                            </p>
                        </div>
                    </div>
                </div>
                
                <div class="quiz" title="KMP Algorithm Quiz">
                <div class="longt">
                <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>
                
                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question1">
                <div class="art-body">
                <p>Q1. Which one of the following is true in KMP String searching algorithm?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c1">
                <div class="art-body">
                <p>(A) The value of strInd always increases in all iterations.</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c2">
                <div class="art-body">
                <p>(B) The value of strInd remains same in all the iterations. </p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q1-c3">
                <div class="art-body">
                <p>(C) The value of
                strInd may or
                may not increase
                in all the
                iterations but
                it never
                decreases.
                                        </p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c4">
                <div class="art-body">
                <p>(D) None of the above</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>Refer "Concept and Strategy : KMP " for explanation.</p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question2">
                <div class="art-body">
                <p>Q2. How does KMP improve the brute-force-method?</p>
                                </div>
                            </div>
                        </div>
                
                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) By comparing the characters right to left instead of left to right.</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                
                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) By searching for text in pattern instead of pattern in string</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                
                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) By not doing
                reduntant
                comparisons and
                using the
                information
                gained from
                previous
                comparisons
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                
                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) None of the above</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>Refer to "Concept and Strategy : KMP"</p>
                                </div>
                            </div>
                        </div>
                    </div>
                
                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question3">
                <div class="art-body">
                <p>Q3. What is the time complexity of KMP Algorithm?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) \( O(M \times N) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) \( O(M ^ N) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) \( O(M + N) \)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) All of the above</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                
                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>The complexity of
                this algorithm will
                be discussed in
                detail in the next
                learning unit.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            
            <div class="lu" title="Preprocessing of KMP Algorithm">
                            <div class="longt">
                            <h2 class="hlongt">Preprocessing of the KMP Algorithm</h2>
            </div>

                            <div class="preamble">
                            <div class="art txt" title="Estimation">
                <div class="longt">
                <h2 class="hlongt">Estimated Time</h2>
                        </div>
                <div class="art-body">
                <p>35 minutes</p>
                        </div>
                    </div>

                <div class="art req" title="Analysis of KMP Algorithm">
                <div class="longt">
                <h2 class="hlongt">Analysis of KMP Algorithm</h2>
                        </div>
                <div class="description">
                <p>Time complexity of KMP algorithm is explained</p>
                        </div>
                </div>

                <div class="art txt" title="Learning Objectives">
                <div class="longt">
                <h2 class="hlongt">Learning Objectives of this Module</h2>
                        </div>
                <div class="art-body">
                <p>In this module, we will be learning about :</p>
                <ul>
                <li>
                Time and Space Complexity:
                We will learn about the
                running time of the
                preprocessing and KMP
                algorithm.
                                </li>
                <li>
                The preprocessing
                algorithm required for
                the KMP algorithm.
                                </li>
                <li>
                Comparison with the
                Naive string searching
                algorithm.
                                </li>
                            </ul>                            
                        </div>
                    </div>
                </div>

                <div class="task" title="Concept and Strategy : Preprocessing">
                <div class="longt">
                <h2 class="hlongt">Concept and Strategy : Preprocessing</h2>
                    </div>

                <div class="art txt" title="Introduction">
                <div class="longt">
                <h2 class="hlongt">Introduction</h2>
                        </div>
                <div class="art-body">
                <ul>
                <li>The preprocessing for
                the KMP algorithm
                involves using the
                pattern string to create
                an auxiliary array
                called LPS (of size same
                as that of the pattern)
                which will be used to
                skip character
                comparisons while
                matching to save time.
                                </li>
                <li>The name LPS indicates
                longest proper prefix
                which is also a proper
                suffix.  LPS[i]
                essentially stores the
                length of maximum proper
                prefix which is also a
                suffix of the string
                LPS[0 to i] .
                                </li>
                            </ul>                            
                        </div>
                    </div> 
                
                <!--div class="art req" title="Tutorial Video">
                <div class="longt">
                <h2 class="hlongt">Tutorial Video</h2>
                        </div>
                <div class="description">
                <p>Insert Video here...</p>
                        </div>
                </div-->

                <div class="art txt" title="Explanation and Algorithm">
                <div class="longt">
                <h2 class="hlongt">Explanation and Algorithm</h2>
                        </div>
                <div class="art-body">
                <b>How to fill LPS[i]?</b>
                <ul>
                <li>We need to know the
                longest suffix until i
                that matches with
                prefix. The longest
                suffix till i-1 that
                matches with some prefix
                (say Pat[0 to j-1]) is
                Pat[i-j to i-1] .
                                </li>
                <li>If the character Pat[j]
                matches with Pat[i] then
                the value of LPS[i] =
                LPS[i-1] + 1
                                </li>
                <li>And if Pat[i] != Pat[j]
                , then the longest
                suffix till i might be
                the second longest
                suffix till i-1 along
                with the character
                Pat[i] and the character
                next to the second
                longest prefix of i-1
                and so on.
                                </li>
                <li>
                <b>How do we find the second longest suffix until i-1 and so on?</b>
                <ul>
                <li>We know that
                Pat[0 to j-1] is
                same as Pat[i-j
                to i-1] and
                LPS[i-1] = j .
                                        </li>
                <li>Therefore,
                finding the
                second longest
                prefix suffix is
                same as finding
                the longest
                prefix suffix of
                Pat[0 to j-1]
                since this
                suffix of Pat[0
                to i-1] would
                also be the
                suffix of Pat[0
                to j-1].
                                        </li>
                <li>LPS[i] would be
                equal to
                LPS[LPS[i-1]] +
                1 if Pat[i] =
                Pat[LPS[i-1]].
                                        </li>
                <li>This same logic
                can be used
                recursively to
                find LPS[i].
                                        </li>
                                    </ul>
                                </li>
                            </ul>
                        </div>
                    </div>

                <div class="art req" title="Preprocessing Visualization">
                <div class="longt">
                <h2 class="hlongt">Pictorial Representation of Preprocessing</h2>
                        </div>
                <div class="description">
                <p>Image here</p>
                        </div>
                    </div>

                <div class="art txt" title="Pseudocode">
                <div class="longt">
                <h2 class="hlongt">Pseudocode</h2>
                        </div>
                <div class="art-body">
                <pre style="font-size: 1vw">
                                function LPS_ArrayGenerator(string Pat){
                                    LPS = Array[Pat.length] 
                                    
                                    j = 0
                                    LPS[0] = 0
                                    
                                    for(int i=1 ; i &lt; Pat.length() ; i++){
                                        while( j > 0 && Pat[i] != Pat[j] ) {
                                            j = LPS[j-1]
                                        }
                                        if(Pat[i] == Pat[j]){ j++ }
                                        LPS[i] = j 
                                    }
                                    
                                    return LPS
                                }
                            </pre>
                        </div>
                    </div>
                </div>

                <div class="task" title="Preprocessing Demo">
                <div class="longt">
                <h2 class="hlongt">Demonstration of the Preprocessing Algorithm</h2>
                    </div>

                <div class="art req" title="Preprocessing Demo">
                <div class="longt">
                <h2 class="hlongt">Preprocessing Demonstration</h2>
                        </div>
                <div class="description">
                <p>Interactive artefact where
                user can click on Next Step
                to understand how the kmp
                string searching algorithm
                works.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="task" title="Analysis of the KMP String Searching Algorithm">
                            <div class="longt">
                            <h2 class="hlongt">Time and space complexity</h2>
                    </div>

                <div class="art txt" title="Time complexity of the preprocessing ">
                <div class="longt">
                <h2 class="hlongt">Time complexity of the preprocessing algorithm</h2>
                        </div>
                <div class="art-body">
                <ul>
                <li>There are two nested loops in the algorithm.</li>
                <li>The outer loop increases
                the value of j by 1 in
                each iteration and hence
                it can increase the
                value of j to the
                maximum of \(m\) (where
                \(m\) = length of the
                pattern) throughout the
                runtime of the
                algorithm.
                                </li>
                <li>The inner while loop
                decreases the value of j
                by 1 in each iteration
                hence it can run for the
                maximum of m times
                throughout the runtime
                of the algorithm.
                                </li>
                <li>There the upper bound to
                the runtime of the
                entire preprocessing
                algorithm is \(2m\)
                which is equal to
                \(O(m)\) .
                                </li>
                            </ul>                            
                        </div>
                    </div> 

                <div class="art txt" title="Time complexity of the KMP search algorithm">
                <div class="longt">
                <h2 class="hlongt">Time complexity of the KMP search algorithm</h2>
                        </div>
                <div class="art-body">
                <ul>
                <li>In the entire run of the
                algorithm we observe
                that strInd(variable
                that tracks the index of
                the string) never
                decreases and increases
                by atleast 1 in each
                iteration of the code.
                                </li>
                <li>This shows that the
                upper bound of the
                runtime of the algorithm
                is the length of the
                text string in which the
                pattern has to be
                searched.
                                </li>
                <li>Hence the time complexity =  \(O(n)\) where n = length of the text string.</li>
                            </ul>
                
                        </div>
                    </div> 

                <div class="art txt" title="Comparison with the Naive string searching algorithm">
                <div class="longt">
                <h2 class="hlongt">Comparison with the Naive string searching algorithm</h2>
                        </div>
                <div class="art-body">                           
                <ul>
                <li>The time complexity of
                the naive string
                searching algorithm was
                found to be \(O(m \times
                n)\) in the worst case.
                                </li>
                <li>Whereas we have found a
                method to reduce the
                runtime complexity of
                the algorithm to \(O(m +
                n)\) using the
                information we gain from
                all our previous
                comparisons.
                                </li>
                            </ul>                            
                        </div>
                    </div> 
                </div>

                <div class="quiz" title="Analysis Quiz">
                <div class="longt">
                <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question1">
                <div class="art-body">
                <p>Q1. What is the time
                complexity of the
                prepropressing
                function for a
                pattern of length
                \(M\) ?
                                    </p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c1">
                <div class="art-body">
                <p>(A) \(O(M^2)\)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c2">
                <div class="art-body">
                <p>(B) \(O(M^3)\) </p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c3">
                <div class="art-body">
                <p>(C) \(O(\sqrt{M})\)
                                        </p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q1-c4">
                <div class="art-body">
                <p>(D) \(O(M)\)</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>Refer to "Concept and Strategy : Preprocessing"
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question2">
                <div class="art-body">
                <p>Q2. What is the longest-prefix-suffix for: "ANIDAPOPOANIDA"?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) 5 </p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) 6 </p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) 2</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) 3</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>ANIDA is the longest prefix which is also a suffix.</p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question2">
                <div class="art-body">
                <p>Q3. What is the longest-prefix-suffix for TOOTOOTOOT?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) 1</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) 4</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) 5</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) 2</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>TOOT is the longest prefix suffix. 
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="lu" title="Post Test">
                    <div class="longt">
                <h2 class="hlongt">Post Test of the Experiment</h2>
            </div>

                        <div class="preamble">
                <div class="art txt" title="Estimation">
                <div class="longt">
                <h2 class="hlongt">Estimated Time</h2>
                        </div>
                <div class="art-body">
                <p>10 minutes</p>
                        </div>
                    </div>

                <div class="art txt" title="Instructions">
                <div class="longt">
                <h2 class="hlongt">Instructions for Quiz</h2>
                        </div>
                <div class="art-body">
                <p>Post Test includes questions
                on entire experiment
                concepts. Read the questions
                in the quiz section and
                select the correct option
                from the ones
                provided. Please note that
                some questions may have more
                than one correct response.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="quiz" title="Post Test Quiz">
                <div class="longt">
                <h2 class="hlongt">A Quiz with Multiple Choice Questions</h2>
                    </div>
                
                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question1">
                <div class="art-body">
                <p>Q1. What is the overall complexity of the KMP-String-Searching algorithm?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c1">
                <div class="art-body">
                <p>(A) \(O(N \times M)\)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c2">
                <div class="art-body">
                <p>(B) \(O(N^2)\)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q1-c3">
                <div class="art-body">
                <p>(C) \(O(N+M)\)</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q1-c4">
                <div class="art-body">
                <p>(D) None of the above</p> 
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>
                Refer to the Analysis task in preprocessing learning Unit.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question2">
                <div class="art-body">
                <p>Q2. What is the space complexity for the KMP String Searching algorithm?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) \(O(M)\)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B)\(O(N)\)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) \(O(N+M)\)</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) None of the above</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p> \(O(M)\) to store the LPS Array. 
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question3">
                <div class="art-body">
                <p>Q3. What is the LPS array for the pattern: "ababbabbabbababbabb" ?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) 001201201001232101</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) 0012012012012345678</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) 012344567891230120</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) 012344567891230123</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>Enter the above
                pattern in the
                preprocessing
                demonstration pane to
                get a thorough
                understanding.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question4">
                <div class="art-body">
                <p>Q4. Find the LPS array for "AABAAABAA"?</p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) 010122345</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) 010000123</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) 012345678</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) 010010010</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>Enter the above
                pattern in the
                preprocessing
                demonstration pane to
                get a thorough
                understanding.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                
                <div class="mcq">  
                <div class="preamble">
                <div class="art txt" title="question5">
                <div class="art-body">
                <p>Q5. Using the LPS
                array from the
                previous question,
                which character would
                you start comparing
                from if you know that
                the matching failed
                at AABAAAB<b>A</b>A?
                                    </p>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c1">
                <div class="art-body">
                <p>(A) 0</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c2">
                <div class="art-body">
                <p>(B) 1</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="false">
                <div class="preamble">
                <div class="art txt" title="q2-c3">
                <div class="art-body">
                <p>(C) 6</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="choice" data-correct="true">
                <div class="preamble">
                <div class="art txt" title="q2-c4">
                <div class="art-body">
                <p>(D) 3</p>
                                    </div>
                                </div>
                            </div>
                        </div>

                <div class="explanation">
                <div class="art txt" title="Explanation">
                <div class="art-body">
                <p>A look at the LPS
                array(010122345)
                would reveal to us
                that AABAAAB has
                longest-suffix-prefix
                of length 3.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

           

            <div class="lu" title="Further Readings/References">
                <div class="longt">
                <h2 class="hlongt">Further Readings and References of the Experiment</h2>
                </div>

                <div class="preamble">
                <div class="art txt" title="Explore">
                <div class="longt">
                <h2 class="hlongt">Explore More About KMP algorithm</h2>
                        </div>
                <div class="art-body">
                <p>You can explore more about
                the KMP string searching
                algorithm through the
                following resources :
                            </p>                            
                <b>Useful Links :</b>
                <ul>
                <li>
                <a href="https://www.geeksforgeeks.org/kmp-algorithm-for-pattern-searching/">C
                implementation of the KMP Algorithm
                                    </a>
                                </li>
                <li><a href="https://www.codechef.com/tags/problems/kmp">CodeChef</a></li>
                <li><a href="https://www.hackerrank.com/challenges/kmp-problem/problem">HackerRank</a></li>
                            </ul>
                <b>Reference Texts :</b>
                <ul>
                <li>Introduction to
                Algorithms : Thomas
                H. Cormen, Charles
                E. Leiserson, Ronald
                L. Rivest, and Clifford
                Stein.
                                </li>
                <li>Data Structures and
                Algorithms : Mark
                A. Weiss
                                </li>
                            </ul>                            
                        </div>
                    </div>
                </div>
            </div>
        </div>
        
        <script src="js/loader.js"></script>
    </body>
</html>
